'*************************************
'*  VGA 640 x 480 x 16bpp 5:6:5 RGB  *
'*************************************

CON

  intensity	= 80	'0..128

  fclk		= 50_000_000.0
  fpix		= 25_000_000.0
  fset		= (fpix / fclk * 2.0) * float($4000_0000)

  vsync		=	0	'vsync pin (all FPGA boards now)

DAT		org
'
'
' Setup
'
		rdfast	##640*350*2/64,##$1000	'set rdfast to wrap on bitmap

		setxfrq ##round(fset)		'set transfer frequency to 25MHz

		setb	dira+vsync>>5,#vsync	'make vsync pin output

		'the next 4 lines may be commented out to bypass signal level scaling

		setcy	##intensity << 24	'r	set colorspace for rgb
		setci	##intensity << 16	'g
		setcq	##intensity << 08	'b
		setcmod	#%01_0_000_0		'enable colorspace conversion
'
'
' Field loop
'
field		mov	x,#90			'top blanks
		call	#blank

		mov     x,#350			'set visible lines
line		call	#hsync			'do horizontal sync
		xcont	m_rf,#0			'visible line
		djnz    x,#line           	'another line?

		mov	x,#83			'bottom blanks
		call	#blank

		notb	outa+vsync>>5,#vsync	'sync on

		mov	x,#2			'sync blanks
		call	#blank

		notb	outa+vsync>>5,#vsync	'sync off

                jmp     #field                  'loop
'
'
' Subroutines
'
blank		call	#hsync			'blank lines
		xcont	m_vi,#0
		djnz	x,#blank
		ret

hsync		xcont	m_bs,#0			'horizontal sync
		xzero	m_sn,#1
		xcont	m_bv,#0
		ret
'
'
' Initialized data
'
m_bs		long	$CF000000+16		'before sync
m_sn		long	$CF000000+96		'sync
m_bv		long	$CF000000+48		'before visible
m_vi		long	$CF000000+640		'visible

m_rf		long	$2F010000+640		'visible rfword rgb16 (5:6:5)

x		res	1
y		res	1

'
' Bitmap
'
		orgh	$1000 - 70		'justify pixels at $1000
		file	"birds_16bpp.bmp"	'rayman's picture (640 x 350)
