#include <stdio.h>
#include <stdlib.h>

void usage(void)
{
    printf("usage: dumpobj file\n");
    exit(1);
}

int main(int argc, char **argv)
{
    FILE *infile;
    unsigned char type, len;
    char buffer[256];
    int num, value;

    if (argc != 2) usage();

    infile = fopen(argv[1], "rb");

    if (!infile)
    {
        printf("Couldn't open %s\n", argv[1]);
        exit(1);
    }

    while (1)
    {
        if (fread(&type, 1, 1, infile) != 1) break;
        fread(&value, 1, 4, infile);
        if (type == 'E')
        {
            printf("%c %8.8x\n", type, value);
            while (value > 0)
            {
                num = (value > 256) ? 256 : value;
                num = fread(buffer, 1, num, infile);
                if (num <= 0) break;
                value -= num;
            }
            continue;
        }
        fread(&len, 1, 1, infile);
        fread(buffer, 1, len, infile);
        printf("%c %8.8x %s\n", type, value, buffer);
    }

    return 0;
}
